/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */

import { HttpMethod, Url, PhoneNumber, Sid } from '../interfaces';

/**
 * <Response> TwiML for Messages
 */
declare class MessagingResponse {
  /**
   * <Response> TwiML for Messages
   */
  constructor();

  /**
   * <Message> TwiML Verb
   *
   * @param attributes - TwiML attributes
   * @param body - Message Body
   *
   * @returns Message
   */
  message(attributes?: MessagingResponse.MessageAttributes, body?: string): MessagingResponse.Message;
  /**
   * <Redirect> TwiML Verb
   *
   * @param attributes - TwiML attributes
   * @param url - Redirect URL
   */
  redirect(attributes: MessagingResponse.RedirectAttributes, url: string): void;
  /**
   * Convert to TwiML
   *
   * @returns TwiML XML
   */
  toString(): any;
}

declare namespace MessagingResponse {

  /**
   * Attributes for <Response> TwiML for Messages
   */
  export interface MessagingResponseAttributes {
  }

  /**
   * Attributes for <Message> TwiML Verb
   */
  export interface MessageAttributes {
    /**
     * Action URL
     */
    action?: string;
    /**
     * Phone Number to send Message from
     */
    from?: string;
    /**
     * Action URL Method
     */
    method?: string;
    /**
     * Status callback URL. Deprecated in favor of action.
     */
    statusCallback?: string;
    /**
     * Phone Number to send Message to
     */
    to?: string;
  }

  /**
   * Attributes for <Redirect> TwiML Verb
   */
  export interface RedirectAttributes {
    /**
     * Redirect URL method
     */
    method?: string;
  }

  /**
   * Attributes for <Message> TwiML Verb
   */
  export interface MessageAttributes {
    /**
     * Action URL
     */
    action?: string;
    /**
     * Phone Number to send Message from
     */
    from?: string;
    /**
     * Action URL Method
     */
    method?: string;
    /**
     * Status callback URL. Deprecated in favor of action.
     */
    statusCallback?: string;
    /**
     * Phone Number to send Message to
     */
    to?: string;
  }

  /**
   * Attributes for <Redirect> TwiML Verb
   */
  export interface RedirectAttributes {
    /**
     * Redirect URL method
     */
    method?: string;
  }

  /**
   * Attributes for <Body> TwiML Noun
   */
  export interface BodyAttributes {
  }

  /**
   * Attributes for <Media> TwiML Noun
   */
  export interface MediaAttributes {
  }

  /**
   * Attributes for <Body> TwiML Noun
   */
  export interface BodyAttributes {
  }

  /**
   * Attributes for <Media> TwiML Noun
   */
  export interface MediaAttributes {
  }

  /**
   * <Message> TwiML Verb
   */
  export class Message {
    /**
     * <Message> TwiML Verb
     *
     * @param message - <Message> TwiML Verb
     */
    constructor(message: any);

    /**
     * <Body> TwiML Noun
     *
     * @param attributes - TwiML attributes
     * @param message - Message Body
     */
    body(attributes: MessagingResponse.BodyAttributes, message: string): void;
    /**
     * <Media> TwiML Noun
     *
     * @param attributes - TwiML attributes
     * @param url - Media URL
     */
    media(attributes: MessagingResponse.MediaAttributes, url: string): void;
  }

}
export = MessagingResponse;
